/* Copyright 2009 Fog Creek Software, Inc. */

using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

/* FogBugz namespaces-- make sure you add the neccesary assembly references to
 * the following DLL files contained in C:\Program Files\FogBugz\Website\bin\ 
 * FogBugz.dll, FogCreek.Plugins.dll, FogCreek.Plugins.InterfaceEvents.dll     */
using FogCreek.FogBugz.Plugins;
using FogCreek.FogBugz.Plugins.Api;
using FogCreek.FogBugz.Plugins.Interfaces;
using FogCreek.FogBugz;
using FogCreek.FogBugz.UI;

namespace IPluginStaticCSS_Example
{
    /* Class Declaration: Inherit from Plugin, expose IPluginStaticCSS */
    public class IPluginStaticCSS_Example : Plugin, IPluginStaticCSS, IPluginPageDisplay, IPluginExtrasMenu
    {
        /* Constructor: We'll just initialize the inherited Plugin class, which 
         * takes the passed instance of CPluginApi and sets its "api" member variable. */
        public IPluginStaticCSS_Example(CPluginApi api): base(api)
        {
        }


        #region IPluginStaticCSS Members

        public string[] StaticCSSFiles()
        {
            /* This file name is relative to the plugin's /static/ folder. */ 
            return new string[]{"css/custom_styles.css"};
        }

        #endregion


        #region IPluginPageDisplay Members

        public string PageDisplay()
        {
            return @"<h1 class=""customHeader"">Custom Styles!</h1>
                    <p class=""customPara"">
                        This plugin page, generated by <b>IPluginPageDisplay</b>,
                        has been styled by a static CSS file specified by the 
                        <b>IPluginStaticCSS</b> interface.
                    </p>";
        }

        public PermissionLevel PageVisibility()
        {
            return PermissionLevel.Normal;
        }

        #endregion

        #region IPluginExtrasMenu Members

        public CNavMenuLink[] ExtrasMenuLinks()
        {
            if (api.Person.GetCurrentPerson().GetPermissionLevel() > PermissionLevel.Community)
                return new CNavMenuLink[] { new CNavMenuLink("See Custom Styles!",
                                                             api.Url.PluginPageUrl()) };
            else
                return new CNavMenuLink[] { };
        }

        #endregion
    }
}

